# Docker精髓笔记（上）

狂神：18集开始看

B站地址：https://www.bilibili.com/video/BV1og4y1q7M4?p=2&spm_id_from=pageDriver

# Docker镜像讲解

## 镜像是什么

镜像是一种轻量级、可执行的独立软件包，用来打包软件运行环境和基于运行环境开发的软件，它包含运行某个软件所需的所有内容，包括代码、运行时、库、环境变量和配置文件。



所有的应用，直接打包成为docker镜像，就可以直接跑起来！

如何得到镜像：

	1. 从远程仓库下载
	2. 朋友拷贝给你
	3. 自己制作一个镜像DockerFile



## Docker镜像加载原理

**UnionFS(联合文件系统)**

我们下载的时候看到的一层层就是这个！

UnionFS(联合文件系统)：Union文件系统（UnionFS）是一种分层、轻量级并且高性能的文件系统，它支持对文件系统的修改作为一次提交来一层层的叠加，同时可以将不同目录挂载到同一个虚拟文件系统下。Union文件系统是Docker镜像的基础。镜像可以通过分层来进行继承，基于基础镜像（没有父镜像），可以制作各种具体的应用镜像。

特性：一次同时加载多个文件系统，但从外面看起来，只能看到一个文件系统，联合加载会把各层文件系统叠加起来，这样最终的文件系统会包含所有底层的文件和目录



**dicker镜像加载原理**

docker的镜像实际上由一层一层的文件系统组成，这种层级的文件系统UnionFS.

![image-20211229162524159](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229162524159.png)



bootfs，黑屏加载（宿主机）

rootfs，（小型）linux系统（可以是不同的linux发行版）



对于精简的OS，rootfs可以很小，只需要包含最进本的命令，工具和程序库就可以了，因为底层直接用Host的Kernel（内核），自己只需要提供rootfs就可以了，由此可见对于不同的linux发行版，bootfs基本是一致的，rootfs会有差别，因此不同的发行版可以工用bootfs。

由此：虚拟机是分钟级别，容器是秒级。



## 分层理解

**分层的镜像**

我们可以去下载一个镜像，注意观察下载的日志输出，可以看到一层一层的在下载！

![image-20211229163852915](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229163852915.png)

**思考：**为什么docker镜像要采用这种分层的结构呢？

最大的好处，我觉得莫过于是资源共享了，比如有多个镜像都从相同的Base镜像构建而来，那么宿主机只需要在磁盘上保留一份Base镜像，同时内存中也只需要加载一份Base镜像，这样就可以为所有的容器服务了，而且镜像的每一层都可以被共享，

查看镜像分层的方式可以通过 **docker image inspect** 命令

Layers下面就是一层一层的镜像

```python
# 测试  docker image inspect redis:latest
[root@hecs-x-large-2-linux-20210314214122 ~]# docker image inspect redis:latest
[
    {
        "Id": "sha256:7614ae9453d1d87e740a2056257a6de7135c84037c367e1fffa92ae922784631",
        "RepoTags": [
            "redis:latest"
        ],
        "RepoDigests": [
            "redis@sha256:db485f2e245b5b3329fdc7eff4eb00f913e09d8feb9ca720788059fdc2ed8339"
        ],
        "Parent": "",
        "Comment": "",
        "Created": "2021-12-21T12:42:49.755107412Z",
        "Container": "13d25f53410417c5220c8dfe8bd49f06abdbcd69faa62a9b877de02464bb04a3",
        "ContainerConfig": {
            "Hostname": "13d25f534104",
            "Domainname": "",
            "User": "",
            "AttachStdin": false,
            "AttachStdout": false,
            "AttachStderr": false,
            "ExposedPorts": {
                "6379/tcp": {}
            },
            "Tty": false,
            "OpenStdin": false,
            "StdinOnce": false,
            "Env": [
                "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin",
                "GOSU_VERSION=1.12",
                "REDIS_VERSION=6.2.6",
                "REDIS_DOWNLOAD_URL=http://download.redis.io/releases/redis-6.2.6.tar.gz",
                "REDIS_DOWNLOAD_SHA=5b2b8b7a50111ef395bf1c1d5be11e6e167ac018125055daa8b5c2317ae131ab"
            ],
            "Cmd": [
                "/bin/sh",
                "-c",
                "#(nop) ",
                "CMD [\"redis-server\"]"
            ],
            "Image": "sha256:e093f59d716c95cfce82c676f099b960cc700432ab531388fcedf79932fc81ec",
            "Volumes": {
                "/data": {}
            },
            "WorkingDir": "/data",
            "Entrypoint": [
                "docker-entrypoint.sh"
            ],
            "OnBuild": null,
            "Labels": {}
        },
        "DockerVersion": "20.10.7",
        "Author": "",
        "Config": {
            "Hostname": "",
            "Domainname": "",
            "User": "",
            "AttachStdin": false,
            "AttachStdout": false,
            "AttachStderr": false,
            "ExposedPorts": {
                "6379/tcp": {}
            },
            "Tty": false,
            "OpenStdin": false,
            "StdinOnce": false,
            "Env": [
                "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin",
                "GOSU_VERSION=1.12",
                "REDIS_VERSION=6.2.6",
                "REDIS_DOWNLOAD_URL=http://download.redis.io/releases/redis-6.2.6.tar.gz",
                "REDIS_DOWNLOAD_SHA=5b2b8b7a50111ef395bf1c1d5be11e6e167ac018125055daa8b5c2317ae131ab"
            ],
            "Cmd": [
                "redis-server"
            ],
            "Image": "sha256:e093f59d716c95cfce82c676f099b960cc700432ab531388fcedf79932fc81ec",
            "Volumes": {
                "/data": {}
            },
            "WorkingDir": "/data",
            "Entrypoint": [
                "docker-entrypoint.sh"
            ],
            "OnBuild": null,
            "Labels": null
        },
        "Architecture": "amd64",
        "Os": "linux",
        "Size": 112691373,
        "VirtualSize": 112691373,
        "GraphDriver": {
            "Data": {
                "LowerDir": "/var/lib/docker/overlay2/a32975efecdd8bd2fbbd1ce63e68a298c3e8322ffac5a976933592356ac9fff8/diff:/var/lib/docker/overlay2/12688bfbeda30bde44eb28e6f22ef03c3340cb865e5255c8c2e154cb769a7c9f/diff:/var/lib/docker/overlay2/3f9298e2a287fe5ad0116c6ee6052fc88f30e8ae1e2d8dc7b67a41765f98ef65/diff:/var/lib/docker/overlay2/074dc240d9b738eeff075279ff3d625cd32a444d4610caeefdb64403b5e41ec1/diff:/var/lib/docker/overlay2/e9138dbdf7eaafce2c093645d9d70dd400141943a8ab44ac3f2281415bab0e7a/diff",
                "MergedDir": "/var/lib/docker/overlay2/c6c982ac130296c0ff6dad812cae6b7284a1620049a0f2a3f3f336dd9813e369/merged",
                "UpperDir": "/var/lib/docker/overlay2/c6c982ac130296c0ff6dad812cae6b7284a1620049a0f2a3f3f336dd9813e369/diff",
                "WorkDir": "/var/lib/docker/overlay2/c6c982ac130296c0ff6dad812cae6b7284a1620049a0f2a3f3f336dd9813e369/work"
            },
            "Name": "overlay2"
        },
        "RootFS": {
            "Type": "layers",
            
            
            "Layers": [   #    这里这里这里这里这里这里这里这里
                "sha256:2edcec3590a4ec7f40cf0743c15d78fb39d8326bc029073b41ef9727da6c851f",
                "sha256:9b24afeb7c2f21e50a686ead025823cd2c6e9730c013ca77ad5f115c079b57cb",
                "sha256:4b8e2801e0f956a4220c32e2c8b0a590e6f9bd2420ec65453685246b82766ea1",
                "sha256:529cdb636f61e95ab91a62a51526a84fd7314d6aab0d414040796150b4522372",
                "sha256:9975392591f2777d6bf4d9919ad1b2c9afa12f9a9b4d260f45025ec3cc9b18ed",
                "sha256:8e5669d8329116b8444b9bbb1663dda568ede12d3dbcce950199b582f6e94952"
            ]
        },
        "Metadata": {
            "LastTagTime": "0001-01-01T00:00:00Z"
        }
    }
]

```



**理解：**

所有的docker镜像都起始于一个基础镜像层，当进行修改或者增加新的内容时，就会在当前镜像层之上，创建新的镜像层。

举一个简单的例子，假如基于Ubuntu Linux 16.04 创建一个新的镜像，这就是新镜像的第一层；如果在该镜像中添加python包，就会在基础镜像层之上创建第二个镜像层；如果继续提娜佳一个安全补丁，就会创建第三个镜像层。

该镜像当前已经包含3个镜像层，如下图所示

![image-20211229164902871](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229164902871.png)

在添加额外的镜像层的同时，镜像始终保持是当前所有镜像的组合，理解这一点非常重要，下图中举一个简单的列子，每个镜像层包含3个文件，而镜像包含了来自两个镜像层的6个文件。

![image-20211229165110828](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229165110828.png)

上图中的镜像层跟之前图中的略有区别，主要目的是便于展示文件

下图中展示了一个稍微复杂的三层镜像，在外部看来整个镜像只有6个文件，这是因为最上层中的文件7是文件5的一个更新版。

![image-20211229165539421](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229165539421.png)

这种情况下，上层镜像层中的文件覆盖了底层镜像中的文件。这样就使得文件的更新版本作为一个新镜像层添加到镜像当中。

docker通过存储引擎（新版本采用快照机制）的方式来实现镜像层堆栈，并保证多镜像层对外展示为同意的文件系统。

![image-20211229211059979](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229211059979.png)



**特点：**

docker镜像都是只读的，当容器启动时，一个新的可写层被加载到镜像的顶部；

这一层就是我们通常说的容器层，容器之下的都叫镜像层！



如何提交一个自己的镜像？



## commit镜像

```python 
docker commit 提交容器成为一个新的副本

# 命令和git原理类似
docker commit -m="提交的描述信息" -a="作者" 容器id  目标镜像名：[Tag]
```

实战测试

```python
# 1. 启动一个默认的tomcat

# 2. 发现这个默认的tomcat 是没有wenapps应用，镜像的原因，官方的镜像默认webapps下面是没有文件的！

# 3. 我自己拷贝进去了基本的文件

[root@hecs-x-large-2-linux-20210314214122 ~]# docker ps
CONTAINER ID   IMAGE          COMMAND             CREATED          STATUS          PORTS                                                    NAMES
e49a9c2e6968   b8e65a4d736d   "catalina.sh run"   34 seconds ago   Up 33 seconds   0.0.0.0:8080-             >8080/tcp, :::8080->8080/tcp   peaceful_keldysh
[root@hecs-x-large-2-linux-20210314214122 ~]# docker exec -it e49a9c2e6968 /bin/bash
root@e49a9c2e6968:/usr/local/tomcat# ls
BUILDING.txt     LICENSE  README.md      RUNNING.txt  conf  logs            temp     webapps.dist
CONTRIBUTING.md  NOTICE   RELEASE-NOTES  bin          lib   native-jni-lib  webapps  work
root@e49a9c2e6968:/usr/local/tomcat# cd webapps
root@e49a9c2e6968:/usr/local/tomcat/webapps# ls
root@e49a9c2e6968:/usr/local/tomcat/webapps# cd ..
root@e49a9c2e6968:/usr/local/tomcat# cp -r webapps.dist/* webapps
root@e49a9c2e6968:/usr/local/tomcat# cd webapps
root@e49a9c2e6968:/usr/local/tomcat/webapps# ls
ROOT  docs  examples  host-manager  manager
root@e49a9c2e6968:/usr/local/tomcat/webapps# lsread escape sequence

    
# 4. 接下来，将我的这些操作，做成镜像
# 将我们操作过的容器通过commit提交为一个镜像！我们以后就使用我们修改过的镜像即可，这就是我们自己的一个修改的镜像

[root@hecs-x-large-2-linux-20210314214122 ~]# docker commit -a="yangyang" -m="add webapps" e49a9c2e6968 tomcat02:1.0
sha256:eb000af20bc2905c80e44f7e28d756a891d59a3b50d713a91a21a314fbf06e74
[root@hecs-x-large-2-linux-20210314214122 ~]# docker images
REPOSITORY            TAG       IMAGE ID       CREATED         SIZE
tomcat02              1.0       eb000af20bc2   8 seconds ago   685MB
tomcat                9.0       b8e65a4d736d   6 days ago      680MB
redis                 latest    7614ae9453d1   8 days ago      113MB
nginx                 latest    f6987c8d6ed5   8 days ago      141MB
centos                latest    5d0da3dc9764   3 months ago    231MB
portainer/portainer   latest    580c0e4e98b0   9 months ago    79.1MB
elasticsearch         7.6.2     f29a1ee41030   21 months ago   791MB
[root@hecs-x-large-2-linux-20210314214122 ~]#


```



学习方式说明：理解概念，但是一定要实践，最后实践和理论相结合一次搞定这个知识。

```
如果你想要保存当前容器的状态，就可以通过commit来提交，获得一个镜像，
就好比我们以前学习VM时候的  快照！
```



到了这里才算是入门Docker！





# 容器数据卷

## 什么是容器数据卷

**docker的理念回顾**

将应用和环境打包成一个镜像！

数据？如果数据都在容器中，那么我们容 器删除，数据就会丢失！**需求：数据可以持久化**

MySql，容器删了，删库跑路！**需求：MySql数据可以存储在本地！**

容器之间可以有一个数据共享的技术！Docker容器中产生的数据，同步到本地！

这就是卷技术！目录的挂载，将我们容器内的目录，挂载到Linux上面！



![image-20211229215846947](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229215846947-16407863289081.png)



**总结一句话：容器的持久化和同步操作！容器间也是可以数据共享的！**



## 使用数据卷

**方式一：直接使用命令挂载 -v**



```shell
# 测试
# 1. 查看已有的镜像，有没有centos的镜像，然后将宿主机/home/ceshi路径挂载centos容器的/home路径；
# 2. 宿主机在/home/ceshi挂载的路径下进行增加文件或者操作文件后，看docker中centos容器的/home路径，是否也对应文件增加，和操作文件的结果。


[root@hecs-x-large-2-linux-20210314214122 ~]# docker images
REPOSITORY            TAG       IMAGE ID       CREATED          SIZE
tomcat02              1.0       eb000af20bc2   16 minutes ago   685MB
tomcat                9.0       b8e65a4d736d   6 days ago       680MB
redis                 latest    7614ae9453d1   8 days ago       113MB
nginx                 latest    f6987c8d6ed5   8 days ago       141MB
centos                latest    5d0da3dc9764   3 months ago     231MB
portainer/portainer   latest    580c0e4e98b0   9 months ago     79.1MB
elasticsearch         7.6.2     f29a1ee41030   21 months ago    791MB
[root@hecs-x-large-2-linux-20210314214122 ~]# docker ps -a
CONTAINER ID   IMAGE          COMMAND             CREATED          STATUS          PORTS                                       NAMES
e49a9c2e6968   b8e65a4d736d   "catalina.sh run"   34 minutes ago   Up 34 minutes   0.0.0.0:8080->8080/tcp, :::8080->8080/tcp   peaceful_keldysh
[root@hecs-x-large-2-linux-20210314214122 ~]# cd /home
[root@hecs-x-large-2-linux-20210314214122 home]# ls
test.java
[root@hecs-x-large-2-linux-20210314214122 home]# docker run -it -v /home/ceshi:/home centos /bin/bash

[root@3c401083dcc0 /]# cd /home
[root@3c401083dcc0 home]# ls
[root@3c401083dcc0 home]# cd ..
[root@3c401083dcc0 /]# cd home
[root@3c401083dcc0 home]# ls
[root@3c401083dcc0 home]# cd ..
[root@3c401083dcc0 /]# ls
bin  dev  etc  home  lib  lib64  lost+found  media  mnt  opt  proc  root  run  sbin  srv  sys  tmp  usr  var
[root@3c401083dcc0 /]# cd /home
[root@3c401083dcc0 home]# ls
[root@3c401083dcc0 home]# 

[root@3c401083dcc0 home]# [root@hecs-x-large-2-linux-20210314214122 home]#


[root@hecs-x-large-2-linux-20210314214122 home]# cd /home
[root@hecs-x-large-2-linux-20210314214122 home]# ls
ceshi  test.java
[root@hecs-x-large-2-linux-20210314214122 home]# cd ceshi/
[root@hecs-x-large-2-linux-20210314214122 ceshi]# ls
[root@hecs-x-large-2-linux-20210314214122 ceshi]# touch aa.txt



[root@hecs-x-large-2-linux-20210314214122 ceshi]# docker ps -a
CONTAINER ID   IMAGE          COMMAND             CREATED          STATUS          PORTS                                       NAMES
3c401083dcc0   centos         "/bin/bash"         3 minutes ago    Up 3 minutes                                                loving_herschel
e49a9c2e6968   b8e65a4d736d   "catalina.sh run"   38 minutes ago   Up 38 minutes   0.0.0.0:8080->8080/tcp, :::8080->8080/tcp   peaceful_keldysh
[root@hecs-x-large-2-linux-20210314214122 ceshi]# docker exec -it 3c401083dcc0 /bin/bash
[root@3c401083dcc0 /]# cd /home
[root@3c401083dcc0 home]# ls
aa.txt
[root@3c401083dcc0 home]#


```

docker inspect 容器id，进入查看Mounts，挂载

没有信息说明，挂载失败。



![image-20211229221623845](Docker%E7%B2%BE%E9%AB%932.assets/image-20211229221623845.png)



好处：我们以后修改只需要在本地修改即可，容器内会自动同步！

无论是宿主机修改文件，或者容器修改文件，都会同步修改！

并且容器关闭后，删除后，宿主机路径下文件依旧存在，不会消失。



## 实战：部署MySql



```python
# 1. docker search mysql
# 2. docker pull mysql：5.7
# 3. 运行时，需要做数据挂载！ # 安装启动mysql， 需要配置密码的，这是要注意点！
# 配置时，一定要去docker hub上去找
# 官方测试：docker run --name some-mysql -e MYSQL_ROOT_PASSWORD=my-secret-pw -d mysql:tag
# 4. 我们运行的命令：
docker run -d -p 3310:3306 -v /home/mysql/conf:/etc/mysql/conf.d -v /home/mysql/data:/var/lib/mysql -e MYSQL_ROOT_PASSWORD=123456 --name mysql01 mysql:5.7
# -d 后台运行
# -p 端口映射
# -v 卷挂载
# -e 环境配置
# --name 容器名字
```

运行后，成功连接！

![image-20211230103808097](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230103808097.png)



3310和容器内的3306映射

新增数据库，看宿主机和容器内是否有新增的数据库信息；

![image-20211230104526819](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230104526819.png)

```python
# 在docker容器中，也是有test数据库

[root@hecs-x-large-2-linux-20210314214122 data]# docker exec -it 64c43c102ec6 /bin/bash
root@64c43c102ec6:/# cd /home
root@64c43c102ec6:/home# ls
root@64c43c102ec6:/home# cd /etc/mysql/
root@64c43c102ec6:/etc/mysql# ls
conf.d  my.cnf  my.cnf.fallback  mysql.cnf  mysql.conf.d
root@64c43c102ec6:/etc/mysql# cd /var/lib/mysql
root@64c43c102ec6:/var/lib/mysql# ls
auto.cnf    client-cert.pem  ib_logfile0  ibtmp1              private_key.pem  server-key.pem
ca-key.pem  client-key.pem   ib_logfile1  mysql               public_key.pem   sys
ca.pem      ib_buffer_pool   ibdata1      performance_schema  server-cert.pem  test  # 这个！
root@64c43c102ec6:/var/lib/mysql#

```



假如，我们删除掉容器，

可以从下看到，依旧有数据在宿主机上，没有出现容器删除后，数据也删除的情况。

```python
[root@hecs-x-large-2-linux-20210314214122 data]# docker ps -a
CONTAINER ID   IMAGE       COMMAND                  CREATED          STATUS          PORTS                                                  NAMES
64c43c102ec6   mysql:5.7   "docker-entrypoint.s…"   57 minutes ago   Up 57 minutes   33060/tcp, 0.0.0.0:3310->3306/tcp, :::3310->3306/tcp   mysql01
[root@hecs-x-large-2-linux-20210314214122 data]# docker rm -f 64c43c102ec6
64c43c102ec6
[root@hecs-x-large-2-linux-20210314214122 data]# docker ps -a
CONTAINER ID   IMAGE     COMMAND   CREATED   STATUS    PORTS     NAMES
[root@hecs-x-large-2-linux-20210314214122 data]# cd /home/mysql/
[root@hecs-x-large-2-linux-20210314214122 mysql]# ls
conf  data
[root@hecs-x-large-2-linux-20210314214122 mysql]# cd data/
[root@hecs-x-large-2-linux-20210314214122 data]# ls
auto.cnf    client-cert.pem  ibdata1      ibtmp1              private_key.pem  server-key.pem
ca-key.pem  client-key.pem   ib_logfile0  mysql               public_key.pem   sys
ca.pem      ib_buffer_pool   ib_logfile1  performance_schema  server-cert.pem  test
[root@hecs-x-large-2-linux-20210314214122 data]#

```



## 具名和匿名挂载

```python
# 1. 匿名挂载
-v 容器内路径
docker run -d -P --name nginx01 -v /etc/nginx nginx
# -P 大P，代表随机端口

# 查看所有的volume的情况
[root@hecs-x-large-2-linux-20210314214122 data]# docker volume ls
DRIVER    VOLUME NAME
local     5a43f58fc0aedf3e2834b3c2494782c2ac5351f253c4951b440159cf89d35a5c
local     c2ffdd3e4f1ecea6f7bac4b1bff9082c818d2620abeeb1677c314b58ff907268


# 这里发现，这种就是匿名挂载，我们在-v 只写了容器内的路径，没有写容器外的路径！

# 2. 具名挂载
[root@hecs-x-large-2-linux-20210314214122 data]# docker run -d -P --name nginx02 -v juming-nginx:/etc/nginx nginx
c0f565055cb22223e64c782c6014b08feea859fabe3dfbfdb41189060c3effa7

[root@hecs-x-large-2-linux-20210314214122 data]# docker volume ls
DRIVER    VOLUME NAME
local     5a43f58fc0aedf3e2834b3c2494782c2ac5351f253c4951b440159cf89d35a5c
local     c2ffdd3e4f1ecea6f7bac4b1bff9082c818d2620abeeb1677c314b58ff907268
local     juming-nginx   # 这个是具名！

# 通过 -v 卷名：容器内路径

# 3. 查看一下这个卷


```

![image-20211230114027748](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230114027748.png)



所有的docker容器内的卷，没有指定目录的情况下都是在`/var/lib/docker/volumes/`下！

我们通过具名挂载可以方便的找到我们的一个卷，大多数情况在使用时`具名挂载`



```python
# 如何确定是具名挂载还是匿名挂载，还是指定路径挂载！
-v 容器内路径       # 匿名挂载
-v 卷名：容器内路径  # 具名挂载
-v 宿主机路径：容器内路径   # 指定路径挂载
```



拓展：

```python
# 通过 -v 容器内路径，ro ,rw改变读写权限
ro  readonly   # 只读
rw  readwrite  # 可读可写

# 一旦这个设置了容器权限，容器对我们挂载出来的内容就有限定了
docker run -d -P --name nginx02 -v juming-nginx:/etc/nginx:ro nginx
docker run -d -P --name nginx02 -v juming-nginx:/etc/nginx:rw nginx
        
# ro 只要看到ro就说明这个路径只能通过宿主机来操作，容器内部是无法操作！
```



## 初始DockerFile

dockerfile就是用来构建docker镜像的构建文件！命令脚本！体验一下。

通过这个脚本可以生成镜像，镜像是一层一层的，脚本一个个的命令，每个命令都是一层！

**方式二：**使用dockerfile进行卷挂载

```python
# 创建一个dockerfile的文件，名字可以随机（建议就是dockerfile）
# 文件中的内容  指令（大写）  参数
FROM centos

VOLUME ["volume01","volume02"]

CMD echo "-----end-----"
CMD /bin/bash

# 这里的每个命令，就是镜像的一层
```

```python
# 通过dockerfile进行制作镜像
docker build -f /home/docker-test-volume/dockerfile1 -t yangyang/centos:1.0 .
# 命令不要敲错。后面有个点呢

```



测试

```python
# 查看已经存在的镜像

[root@hecs-x-large-2-linux-20210314214122 ~]# docker images
REPOSITORY            TAG       IMAGE ID       CREATED         SIZE
tomcat02              1.0       eb000af20bc2   16 hours ago    685MB
tomcat                9.0       b8e65a4d736d   7 days ago      680MB
redis                 latest    7614ae9453d1   8 days ago      113MB
nginx                 latest    f6987c8d6ed5   9 days ago      141MB
mysql                 5.7       c20987f18b13   9 days ago      448MB
centos                latest    5d0da3dc9764   3 months ago    231MB
portainer/portainer   latest    580c0e4e98b0   9 months ago    79.1MB
elasticsearch         7.6.2     f29a1ee41030   21 months ago   791MB

# 在home/docker-test-volume路径下,创建dockerfile

[root@hecs-x-large-2-linux-20210314214122 ~]# cd /home
[root@hecs-x-large-2-linux-20210314214122 home]# ls
ceshi  mysql  test.java

[root@hecs-x-large-2-linux-20210314214122 home]# mkdir docker-test-volume
[root@hecs-x-large-2-linux-20210314214122 home]# ls
ceshi  docker-test-volume  mysql  test.java
[root@hecs-x-large-2-linux-20210314214122 home]# cd docker-test-volume/
[root@hecs-x-large-2-linux-20210314214122 docker-test-volume]# vim dockerfile
[root@hecs-x-large-2-linux-20210314214122 docker-test-volume]# cat dockerfile
FROM centos

VOLUME ["volume01","volume02"]

CMD echo "-----end-----"
CMD /bin/bash

# 执行构建镜像的命令
[root@hecs-x-large-2-linux-20210314214122 docker-test-volume]# docker build -f dockerfile -t yangyang/centos:1.0 .
Sending build context to Docker daemon  2.048kB
Step 1/4 : FROM centos
 ---> 5d0da3dc9764
Step 2/4 : VOLUME ["volume01","volume02"]
 ---> Running in 5d99e9690cd2
Removing intermediate container 5d99e9690cd2
 ---> 5409437e4dc4
Step 3/4 : CMD echo "-----end-----"
 ---> Running in e704467861b0
Removing intermediate container e704467861b0
 ---> 6b7a08780e18
Step 4/4 : CMD /bin/bash
 ---> Running in bc4f4cbe154a
Removing intermediate container bc4f4cbe154a
 ---> f5674dd4645a
Successfully built f5674dd4645a
Successfully tagged yangyang/centos:1.0
[root@hecs-x-large-2-linux-20210314214122 docker-test-volume]# docker images
REPOSITORY            TAG       IMAGE ID       CREATED          SIZE
yangyang/centos       1.0       f5674dd4645a   10 seconds ago   231MB


# 可以看到下图：
```

![image-20211230143608274](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230143608274.png)



启动下我们自己创建的镜像！

这个目录就是我们生成镜像的时候，自动挂载，数据卷目录

![image-20211230143902510](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230143902510.png)

```python
```

![image-20211230144026284](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230144026284.png)

所以，在宿主机中，docker默认卷挂载的路径下，肯定有对应容器中的卷。通过docker inspect 容器id，就可以看到mounts下挂载的卷。

![image-20211230144410107](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230144410107.png)



测试下容器中，卷路径下创建一个文件，是否同步宿主机上？



这种方式（dockerfile）我们未来使用的十分多，因为我们通常会构建自己的镜像！

假设构建镜像时候没有挂载卷，要手动镜像挂载，-v卷名：容器内路径



## 数据卷容器

容器与容器之间同步；

两个mysql同步数据，多个mysql数据同步怎么做呢？

![image-20211230145053475](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230145053475.png)

数据卷容器，说白了，就是利用这个容器，给别的容器去共享数据罢了。



```python
# 启动三个容器，通过我们刚才自己写的镜像启动；
# dockerfile内容：
FROM centos

VOLUME ["volume01","volume02"]

CMD echo "-----end-----"
CMD /bin/bash
# 启动命令
docker build -f dockerfile -t yangyang/centos:1.0 .
```

测试

步骤1：启动docker01，

![image-20211230151142989](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230151142989.png)

crtl+p+q，不结束容器运行，的方式退出容器；

exit ，结束容器运行，的方式退出容器；



步骤2：启动docker02

`docker run -it --name docker02 --volumes-from docker01 yangyang/centos:1.0`

![image-20211230151814391](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230151814391.png)



验证：在容器docker01里面volume路径创建文件后，docker02会不会同步数据呢？



![image-20211230152214660](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230152214660.png)

验证，没有毛病



步骤3：在启动一个docker03，也和docker01挂载上，并且docker03文件增加后，docker01与docker02，也同步了该增加的数据。

![image-20211230152831422](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230152831422.png)



步骤4：dockero01的容器删除，那么文件是否还在呢?

结果显而易见，依旧存在！

![image-20211230153200014](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230153200014.png)



所以：这个并不是共享的概念，而是互相拷贝的情况！

![image-20211230153305461](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230153305461.png)





思考：一般容器数据卷用来干什么呢？

多个mysql实现数据共享；

```python
docker run -d -p 3310:3306 -v /etc/mysql/conf.d -v /var/lib/mysql -e MYSQL_ROOT_PASSWORD=123456 --name mysql01 mysql:5.7
        

docker run -d -p 3311:3306 -e MYSQL_ROOT_PASSWORD=123456 --name mysql02 --volumes-from mysql01 mysql:5.7
        
        
挂载的时候，不要用共同的端口！
这样两个数据库之间就实现了数据的共享！
```





结论：

容器之间配置信息的传递，数据卷容器的生命周期一直持续到没有容器使用为止。

一旦持久化到了本地，这个时候，本地是不会删除的！





# DockerFile

## DockerFile介绍

核心：用来构建docker镜像的文件！命令参数脚本！

构建步骤：

1. 编写一个dockerfile文件
2. docker build构建成为一个镜像
3. docker run  运行镜像
4. docker push 发布镜像（docker hub、 阿里云镜像仓库）

查看一下官方是怎么做镜像的！

![image-20211230155208458](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230155208458.png)



很多官方镜像都是基础包，很多功能没有，我们通常自己搭建自己的镜像！

官方既然可以制作镜像，我们也可以！



## DockerFile构建过程

基础知识：

1. 每个保留关键字（指令）都是必须是大写字母
2. 执行从上到下顺序执行
3. #标识注释
4. 每一个指令都会创建提交一个新的镜像层，并提交！



![image-20211230162136454](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230162136454.png)



dockerFile是面向开发的，我们以后要发布项目，做镜像，就需要编写dockerFile文件，这个文件十分简单！

Docker镜像逐渐成为企业交付的标准，必须要掌握！

（现在我们的身份就逐渐由执行的人，变为了做的人了！）



步骤：开发、部署、运维。。。缺一不可

DockerFile：构建文件，定义了一切的步骤，源代码

DockerImages：通过DockerFIle构建生成的镜像，最终发布和运行的产品

Docker容器：容器就是镜像运行起来提供服务器



## DockerFiel的指令

以前的话，我们就是使用别人的，现在我们知道了这些指令后，我们来练习自己写一个镜像！

```python
FROM  # 基础镜像，一切从这里开始构建
MAINTAINER  # 镜像是谁写的，姓名+邮箱
RUN         # 镜像构建的时候，需要运行的命令
ADD         # 步骤，tomcat镜像，这个tomcat压缩包！添加内容
WORKDIR     # 镜像的工作目录
VOLUME      # 挂载的目录
EXPOST      # 保留端口配置
CMD         # 指定这个容器启动的时候要运行的命令，只有最后一个会生效，可被替代
ENTRYPOINT  # 指定这个容器启动的时候要运行的命令，可以追加命令
ONBUILD     # 当构建一个被继承DockerFile这个时候就会运行ONBUILD的指令。触发指令。
COPY        # 类似ADD,将我们文件拷贝到镜像中
ENV         # 构建的时候设置环境变量！
```

![image-20211230163410038](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230163410038.png)



## 实战测试

DockerHub中99%的镜像都是从这个基础镜像过来的FROM scratch，然后配置需要的软件和配置来进行的构建。

如：centos

![image-20211230163551283](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230163551283.png)



**创建一个自己的centos镜像**

在home目录下，创建文件夹dockerfile，在这个文件夹内放自己编写的dockerfile文件；

1. 步骤1：编写自己的dockerfile

```python

FROM centos

MAINTAINER yangyang<1013925784@qq.com>

ENV MYPATH /usr/local
WORKDIR $MYPATH

RUN yum -y install vim
RUN yum -y install net-tools

EXPOSE 80

CMD echo $MYPATH
CMD echo "-----end-----"
CMD /bin/bash

```



 2. 步骤2：构建镜像

    `docker build -f my-dockerfile-centos -t mycentos:1.0 .`

    -f  # dockerfile文件路径

    -t  # 创建目标的镜像名字和tag号

    .    # 千万不要忘记有个点

    ![image-20211230174007020](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230174007020.png)



3. 步骤3：运行自己通过dockerfile创建的镜像，并测试

`docker run -it mycentos:0.1`

![image-20211230174817230](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230174817230.png)

我们增加之后的镜像



**我们可以列出本地镜像的变更历史**

`docker history 镜像id`

![image-20211230175258036](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230175258036.png)



我们平时拿到一个镜像，可以研究一下他说怎么做的了。



## CMD和ENTRYPOINT区别

```python
CMD         # 指定这个容器启动的时候要运行的命令，只有最后一个会生效，可被替代。
ENTRYPOINT  # 指定这个容器启动的时候要运行的命令，可以追加命令。
```



1. 测试cmd

```python
# 编写dockerfile文件
FROM centos

CMD ["ls","-a"]

# 构建镜像
docker build -f dockerfile-cmd-test -t cmdtest .

# run运行，发现我们的ls -a命令生效
docker run fbb588399e39

# 想追加一个命令 -l   最终组成ls -al,发现报错
[root@hecs-x-large-2-linux-20210314214122 ~]# docker run fbb588399e39 -l
docker: Error response from daemon: OCI runtime create failed: container_linux.go:380: starting container process caused: exec: "-l": executable file not found in $PATH: unknown.

# cmd的清理下 ，-l代替了CMD ["ls","-a"] 命令， -l不是命令所以报错。写全命令时，正常运行了。
[root@hecs-x-large-2-linux-20210314214122 ~]# docker run fbb588399e39 ls -al
total 56
drwxr-xr-x   1 root root 4096 Dec 31 02:26 .
drwxr-xr-x   1 root root 4096 Dec 31 02:26 ..
-rwxr-xr-x   1 root root    0 Dec 31 02:26 .dockerenv
lrwxrwxrwx   1 root root    7 Nov  3  2020 bin -> usr/bin
drwxr-xr-x   5 root root  340 Dec 31 02:26 dev
drwxr-xr-x   1 root root 4096 Dec 31 02:26 etc
drwxr-xr-x   2 root root 4096 Nov  3  2020 home
lrwxrwxrwx   1 root root    7 Nov  3  2020 lib -> usr/lib
lrwxrwxrwx   1 root root    9 Nov  3  2020 lib64 -> usr/lib64


```



![image-20211230180309451](Docker%E7%B2%BE%E9%AB%932.assets/image-20211230180309451.png)



2.测试ENTRYPOINT



![image-20211231103835351](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231103835351.png)



dockerfile中很多命令都十分的相似，我们需要了解他们的区别，我们最好的学习就是对比他们然后测试。



## 实战：Tomcat镜像

1. 准备镜像文件 tomcat压缩包，jdk的压缩包；

2. 编写dockerfile文件，官方命名`dockerfile`,bulid会自动寻找这个文件，就不要-f指定了。

   ![image-20211231142114664](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231142114664.png)

```python
FROM centos
MAINTAINER yangyang<z18217276943@163.com>

COPY readme.txt /usr/local/readme.txt

ADD jdk-8u11-linux-x64.tar.gz /usr/local/
ADD apache-tomcat-9.0.22.tar.gz /usr/local/

RUN yum -y install vim

ENV MYPATH /usr/local
WORKDIR $MYPATH

ENV JAVA_HOME /usr/local/jdk1.8.0_11
ENV CLASSPATH $JAVA_HOME/lib/dt.jar:$JAVA_HOME/lib/tools.jar
ENV CATALINA_HOME /usr/local/apache-tomcat-9.0.22
ENV CATALINA_BASH /usr/local/apache-tomcat-9.0.22
ENV PATH $PATH:$JAVA_HOME/bin:$CATALINA_HOME/lib:$CATALINA_HOME/bin

EXPOSE 8080

CMD /usr/local/apache-tomcat-9.0.22/bin/startup.sh && tail -F /url/local/apache-tomcat-9.0.22/bin/logs/catalina.out

```

3. `docker build -t diytomcat .`构建镜像；

4. 启动容器

   ![image-20211231141957894](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231141957894.png)

   ![image-20211231142855109](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231142855109.png)



5. 查看挂载的test项目目录和log日志目录

![image-20211231142149314](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231142149314.png)



6. 访问9090端口，看tomcat是否可以访问



7. 发布项目！卷挂载（test目录）

   ![image-20211231143543226](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231143543226.png)

   

   ![image-20211231143216422](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231143216422.png)



成功的图：

![image-20211231142924423](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231142924423.png)

8. 看日志是否打印

![image-20211231143420154](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231143420154.png)

![image-20211231143431886](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231143431886.png)



## 发布自己的镜像

DockerHub，上去注册一个自己的地址：

地址：https://hub.docker.com/choose-plan?ref=signup

1. 确定账号可以登录；

2. 在服务器上提交自己的镜像

3. 服务器上登录dockerhub的账号！

   我的账号：`yangyang1222`

   密码：`Yang1234！`

   ![image-20211231144615206](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231144615206.png)

4. `docker login --help`登录的帮助命令

5. 登录完就可以提交镜像了

   在上传镜像的时候，先使用`docker tag `重新打标，在上传

![image-20211231145719412](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231145719412.png)

发布的时候也是按照层，一层一层的！

![image-20211231151435386](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231151435386.png)



## 发布阿里云镜像

1. 登录阿里云：https://cr.console.aliyun.com/cn-hangzhou/instance/repositories

2. 找到镜像与容器服务

3. 创建命名空间

   ![image-20211231152605425](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231152605425.png)

4. 创建镜像仓库

   ![image-20211231152641457](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231152641457.png)

5. 浏览阿里云，查看牛鬼神蛇

   ![image-20211231153736124](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231153736124.png)

   完全按照阿里云自己写的命令，去执行就欧克！

6. 阿里云容器镜像就参考官方就行；



测试验证：通过！

![image-20211231154231693](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231154231693.png)



## Docker小结：

![image-20211231154037963](Docker%E7%B2%BE%E9%AB%932.assets/image-20211231154037963.png)



到这里，已经算是可以了；

后续在学习，就运维方面的，测试右移，（高薪开始的第一步了。）



# Docker网络（铺垫 容器编排 集群部署！）





企业实战



Docker Compose



Docker Swarm



CI/CD jenkins流水线！