# Docker精髓笔记（下）

狂神：34集开始

B站地址：https://www.bilibili.com/video/BV1og4y1q7M4?p=34



# Docker网络

清空所有的images和容器

以一个干净的空间去学习网络；

获取容器内ip地址的命令：

**`ip addr`**

## 初始Docker0网络



![image-20211231160625750](Docker%E7%B2%BE%E9%AB%933.assets/image-20211231160625750.png)

本机回环地址；

阿里云内网地址；

docker地址

**由图可以看到有三个网络：**

**问题：docker是如何处理容器网络访问的？**

![image-20211231160920149](Docker%E7%B2%BE%E9%AB%933.assets/image-20211231160920149.png)

一个tomcat容器，一个mysql容器，怎么通信的？

测试：

```python
# 思考：容器内部和容器外部，能不能ping通？（废话，肯定能，不然容器还有个der用）
# 服务器说：我自己创建的docker，难道我自己还ping不通，要他何用，斩！
# 步骤如下图：

```

![image-20220104110706444](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104110706444.png)



看图中：宿主机中docker0的网络是：172.17.0.1（默认是路由器的网址）

容器centos中，ip是：172.17.0.2（属于路由器的这个网段，是必须可以ping通的）相当于手机连wifi的路由。



### **原理：**

1.我们每启动一个docker容器，docker就会给docker容器分配一个ip，我们只要安装了docker，就会有一个网卡docker0；默认是桥接模式，使用的技术是evth-pair技术。



2.在启动一个容器，发现，宿主机上又增加了一个网卡。

![image-20220104112205649](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104112205649.png)



3.我们发现：这个容器带来网卡，都是一对对出现；

evth-pair 就是一对的虚拟设备接口，他们都是成对出现的，一段连着协议，一段彼此相连；

正因为有这个特性，evth-pair充当一个桥梁，连接各种虚拟网络设备的；

OpenStac、Docker、容器之间的连接，ovs的连接，都是使用evth-pair 技术。



测试：下tomcat容器1和tomcat容器2之间是否可以ping通？

![image-20220104135228964](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104135228964.png)

结果：是可以ping通的

绘制网络模型图：

![image-20220104140105010](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104140105010.png)

结论：tomcat容器1和tomcat容器2是公用的一个路由器，docker0

所有的容器不指定网络的情况下，都是docker0路由的，docker会给我们的容器分配一个默认的可用IP；

255.255.0.1/16  这个16是什么意思？  域 65535 个ip

docker是使用的桥接：

![image-20220104140506124](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104140506124.png)

docker中的所i有网络接口都是虚拟的，虚拟的转发效率高！（内网传递文件！）10m/s。

只要容器删除，对应网桥一对就没了。



## **思考：**--link

**一个场景，我们编写了一个微服务，database url=ip： ，项目不重启，数据库ip换掉了，我们希望可以处理这个问题，可以名字来进行访问容器？**

--link 可以解决网络联通问题：

```python
[root@hecs-x-large-2-linux-20210314214122 ~]# docker ps -a
CONTAINER ID   IMAGE     COMMAND       CREATED          STATUS                      PORTS     NAMES

a975eef05700   centos    "/bin/bash"   3 hours ago      Up 3 hours                            centos01


# 通过--link既可以解决了网络联通文通
[root@hecs-x-large-2-linux-20210314214122 ~]# docker run -d -it -P --name centos03 --link centos01 centos
caf9ced5a502fba799eb22a976064566c26f946ba7935ac24f3cc8205baf715a
[root@hecs-x-large-2-linux-20210314214122 ~]# docker ps -a
CONTAINER ID   IMAGE     COMMAND       CREATED         STATUS                      PORTS     NAMES
caf9ced5a502   centos    "/bin/bash"   6 seconds ago   Up 6 seconds                          centos03

a975eef05700   centos    "/bin/bash"   3 hours ago     Up 3 hours                            centos01
# 经过验证，可以ping通！
[root@hecs-x-large-2-linux-20210314214122 ~]# docker exec -it centos03 ping centos01
PING centos01 (172.17.0.3) 56(84) bytes of data.
64 bytes from centos01 (172.17.0.3): icmp_seq=1 ttl=64 time=0.066 ms
64 bytes from centos01 (172.17.0.3): icmp_seq=2 ttl=64 time=0.046 ms
64 bytes from centos01 (172.17.0.3): icmp_seq=3 ttl=64 time=0.043 ms
64 bytes from centos01 (172.17.0.3): icmp_seq=4 ttl=64 time=0.045 ms
^C
--- centos01 ping statistics ---
4 packets transmitted, 4 received, 0% packet loss, time 3000ms
rtt min/avg/max/mdev = 0.043/0.050/0.066/0.009 ms

# 但是：正向可以ping通，反向能ping通吗？答案是：不能，也是需要配置的
[root@hecs-x-large-2-linux-20210314214122 ~]# docker exec -it centos01 ping centos03
ping: centos03: Name or service not known

```



查看docker网络

![image-20220104142816921](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104142816921.png)

执行：`docker run -d -it -P --name centos03 --link centos01 centos`时，查看网络区别；在这里看不到；

![image-20220104143223889](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104143223889.png)



**需要进入容器中，直接查看host**

![image-20220104143715793](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104143715793.png)

ps：hosts配置后：

如果在windows的hosts文件配置`127.0.0.4   www.baidu.com`

就相当于，访问百度时，去访问127.0.0.4.



centos03的ip是4；

centos01的ip是3；

配置后，就相当于centos03的网络，就是跟随了centos01的网络。

![image-20220104144935738](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104144935738.png)



以上就--link的使用，但是，这都是给新手玩的；高手都是自定义网络



## 自定义网络

查看所有的docker网络

`docker network ls`

![image-20220104145321550](Docker%E7%B2%BE%E9%AB%933.assets/image-20220104145321550.png)

网络模式：

bridge: 桥接（默认，自己创建网络时，也一般使用这个）

none:    不配置网络（一般不用）

host:     和宿主机共享网络

container: 容器网络联通！（用的少！局限很大，测试用的多）



而自定义网络所解决的问题：

```shell
# docker0特点：默认，域名不能访问，--link可以打通连接！
# 自己ping不同自己网络里的容器！
# 所以自定义网络，将docker0的缺陷，全部补全。
```





测试

`docker network --help`

1.创建网络`create`（创建之前，将所有容器先删除，会更友好的看到测试结果！）

`docker network create --driver bridge --subnet 192.168.0.0/16 --gateway 192.168.0.1 mynet`

```shell
# --driver bridge  # 创建桥接方式的网络
# --subnet 192.168.0.0/16  # 子网，数量是25536；24就少一些
# --gateway 192.168.0.1   # 网关：路由器的地址

[root@hecs-x-large-2-linux-20210314214122 ~]# docker network create --driver bridge --subnet 192.168.0.0/16 --gateway 192.168.0.1 mynet
57f8b2d392aa81bfd763f0551df62d0171e7ba4a722e6addc86563e83e946a03

# 查看自己的网络

```

![image-20220105105626325](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105105626325.png)



2.将tomcat发布到自己的网络里

`docker run -d -P --name tomcat-net-01 --net mynet tomcat`

![image-20220105110555577](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105110555577.png)



检查自己网络里的容器：

![image-20220105110638229](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105110638229.png)



3.测试：自定义网络的优点。

不使用--link，也可以ping名字了



![image-20220105112511765](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105112511765.png)

由图看到：

我们自定义网络docker都已经帮我们维护好了对应的关系，推荐我们平时这样使用网络！



**好处：**

redis - 不同的集群使用不同的网络，保证集群是安全和健康的；

mysql - 不同的集群使用不同的网络，保证集群是安全和健康的；

![image-20220105112851235](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105112851235.png)

他们之间是互相隔离的！



**网络联通：**

如果想要连通，怎么做呢？

![image-20220105134352469](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105134352469.png)

步骤：

1. 在docker0网络下创建两个容器；
2. docker0下的容器去ping下mynet网络下的容器，根本是不可能ping通的；
3. 同样docker0网络和mynet网络，也是不可能联通的；
4. 只有通过容器与不同网络进行联通；

测试：

![image-20220105135319768](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105135319768.png)



联通的方法	`connect` 连接一个容器到一个网络；

测试联通：

`docker network connect mynet tomcat01`

![image-20220105135837520](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105135837520.png)

ping一下看看效果：

![image-20220105140033923](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105140033923.png)



总结：

联通之后，就是将centos-01，放到了mynet 网络下！

一个容器两个ip地址！  相当于阿里云服务，一个公网ip，一个私网ip



## 实战：部署redis集群

准备掏钱环节要来了！

后面上云的操作，掏钱更多。。。

`分片 + 高可用 + 负载均衡`，没有使用哨兵模式。

![image-20220105140737746](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105140737746.png)



步骤：

1.创建redis网络

`docker network create --driver bridge --subnet 192.168.0.0/16 --gateway 192.168.0.1 mynet`  这个是mynet网络创建命令；

`docker network create redis --subnet 172.38.0.0/16`  这是redis网络命令；

```shell
# --subnet   # 子网；16就是：255.255
```



2.查看创建的网络

`docker network inspect redis`

![image-20220105142228486](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105142228486.png)



3.创建6个redis配置，通过脚本创建

```python
for port in $(seq 1 6); \
do \
mkdir -p /mydata/redis/node-${port}/conf
touch /mydata/redis/node-${port}/conf/redis.conf
cat << EOF >/mydata/redis/node-${port}/conf/redis.conf
port 6379
bind 0.0.0.0
cluster-enabled yes
cluster-config-file nodes.conf
cluster-node-timeout 5000
cluster-announce-ip 172.38.0.1${port}
cluster-announce-port 6379
cluster-announce-bus-port 16379
appendonly yes
EOF
done

```

![image-20220105144648662](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105144648662.png)



4.启动容器了

```shell
# 第一个
docker run -p 6371:6379 -p 16371:16379 --name redis-1 \
-v /mydata/redis/node-1/data:/data \
-v /mydata/redis/node-1/conf/redis.conf:/etc/redis/redis.conf \
-d --net redis --ip 172.38.0.11 redis:5.0.9-alpine3.11 redis-server /etc/redis/redis.conf

# 解释
-p、--name、-v、-d、--net就不说了；
--ip # 绑定的ip号；和第三步，创建配置时一样
redis:5.0.9-alpine3.11  # redis的版本
redis-server /etc/redis/redis.conf  # 启动的时候，通过redis.conf启动，并且这个时候卷挂载是/mydata/redis/node-1/conf/redis.conf的地方！也就是用的写的这个地方。


# 第二个
docker run -p 6372:6379 -p 16372:16379 --name redis-2 \
-v /mydata/redis/node-2/data:/data \
-v /mydata/redis/node-2/conf/redis.conf:/etc/redis/redis.conf \
-d --net redis --ip 172.38.0.12 redis:5.0.9-alpine3.11 redis-server /etc/redis/redis.conf


# 第三个
docker run -p 6373:6379 -p 16373:16379 --name redis-3 \
-v /mydata/redis/node-3/data:/data \
-v /mydata/redis/node-3/conf/redis.conf:/etc/redis/redis.conf \
-d --net redis --ip 172.38.0.13 redis:5.0.9-alpine3.11 redis-server /etc/redis/redis.conf

# 第四个
docker run -p 6374:6379 -p 16374:16379 --name redis-4 \
-v /mydata/redis/node-4/data:/data \
-v /mydata/redis/node-4/conf/redis.conf:/etc/redis/redis.conf \
-d --net redis --ip 172.38.0.14 redis:5.0.9-alpine3.11 redis-server /etc/redis/redis.conf

# 第五个
docker run -p 6375:6379 -p 16375:16379 --name redis-5 \
-v /mydata/redis/node-5/data:/data \
-v /mydata/redis/node-5/conf/redis.conf:/etc/redis/redis.conf \
-d --net redis --ip 172.38.0.15 redis:5.0.9-alpine3.11 redis-server /etc/redis/redis.conf

# 第六个
docker run -p 6376:6379 -p 16376:16379 --name redis-6 \
-v /mydata/redis/node-6/data:/data \
-v /mydata/redis/node-6/conf/redis.conf:/etc/redis/redis.conf \
-d --net redis --ip 172.38.0.16 redis:5.0.9-alpine3.11 redis-server /etc/redis/redis.conf
```



5.创建集群

先进入一个容器：`docker exec -it redis-1 /bin/sh`  

在执行创建集群命令：`redis-cli --cluster create 172.38.0.11:6379 172.38.0.12:6379 172.38.0.13:6379 172.38.0.14:6379 172.38.0.15:6379 172.38.0.16:6379 --cluster-replicas 1 `

这个就是分片的集群命令。

![image-20220105152249004](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105152249004.png)



6.连接集群

`redis-cli -c`

![image-20220105153841320](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105153841320.png)



7.测试高可用

先set一个值后，将主机删除，看下从机，会不会替代，并且get值的时候，能不能get到

![image-20220105154518488](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105154518488.png)

![image-20220105154755823](Docker%E7%B2%BE%E9%AB%933.assets/image-20220105154755823.png)



由此看出：

我们使用了docker之后，所有的技术都会慢慢的变得简单起来！



## 实战：SpringBoot微服务打包Docker镜像

1.构建springboot项目

2. 打包应用
3. 编写dockerfile
4. 构建镜像
5. 发布运行



以后我们使用Docker之后，给别人交付的就是一个镜像



如果由很多镜像！100镜像，用到到了

Docker compose 编排



# 发现的基本面试问题整理

```
# 基本问题
"""
1. 运行docker run命令的时候，--link参数的原理，如果两个容器分布在不同的机器上无法使用--link，那么我们应该怎么处理？
答案： --link的原理是将目标容器的网络信息已环境变量的形式注入到容器中，所以如果两个容器不在同一台机器上无法使用link参数，
那么可以在启动容器的时候直接使用-e参数设置环境变量来给容器传递网络的IP地址和端口号信息。（问题比较低端；一般更好方法的就是容器联通目标网络；也就是一个容器两个ip地址；）

2. 在docker selenium的开源项目中， 为什么不支持IE镜像？（比较low的问题）
答案： 因为容器并不虚拟化自己的内核，而是在一台机器上的所有容器都使用宿主机的内核。
而docker只能安装在linux系统上（因为容器的底层逻辑需要linux内核的能力），而IE浏览器是使用windows内核驱动的，所以
无法制作ID浏览器的镜像。

3. 如果我们有一个软件要进行部署测试，要测试软件可以兼容各种操作系统，那么可以使用docker启动centos或者redhat镜像来完成测试码？（比较low的问题）
答案： 不可以， 因为容器并不虚拟化自己的内核，而是在一台机器上的所有容器都使用宿主机的内核。所以如果书主机的内核是3.1.0版本，
即便我们启动了名字为centos 6或者centos 7或者其他镜像，那么在容器里仍然使用的是3.1.0的内核，所有总结下来任何对内核有要求
的场景尽量不要使用容器。

"""

# 4.如果我们想在需要排查一个容器中的网络问题，但是容器的镜像并没有安装任何的网络排查工具，也无法通过网络下载工具，这个时候怎么做？（还算可以的问题）
# 答案：创建一个含有网络排查工具的容器，然后进行挂在在容器互通网络中；
# 使用docker网络模式的container模式，进行连接待排查的容器。
# 答案：2. 使用host网络方式，进入容器的网络名称空间，查看网络问题。（算是比较深的题）
还有答案:类似于答案2；
docker inspect “问题容器”；查找到这个有问题容器的PID（进程id，容器本身就是一个进程）；
然后linux中所有进程信息都会映射在“cd /proc/"进程id" ”下，进入这个目录；
目录名字有个“ns”，就是名称空间，进入“ns”这个目录。就是这个进程的所有名称空间；
然后宿主机通过切换网络名称空间的操作，“nsenter -t "进程id" -n ”就切换到容器的网络名称空间了，通过ifconfig，就可以看到容器网络了。退出“exit”。（这个只切换了网络名称空间）
```





# 在服务中注入网络故障

混沌工程；

怎么注入故障？比如注入延迟等，其实也是使用的网络名称空间，iptables切断网络，达到目的；

具体实战，待定；

如果杀掉进程，就可以切换到进程名称空间上



iptables，四表五量
